﻿// <auto-generated />
using EfInheritance.DAL;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace EfInheritance.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    [Migration("20190330163741_test")]
    partial class test
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityAlwaysColumn)
                .HasAnnotation("ProductVersion", "2.1.8-servicing-32085")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            modelBuilder.Entity("EfInheritance.Models.Category", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int>("CategoryGroupId");

                    b.Property<string>("Discriminator")
                        .IsRequired();

                    b.Property<string>("Name");

                    b.HasKey("Id");

                    b.HasIndex("CategoryGroupId");

                    b.ToTable("Category");

                    b.HasDiscriminator<string>("Discriminator").HasValue("Category");
                });

            modelBuilder.Entity("EfInheritance.Models.CategoryGroup", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Discriminator")
                        .IsRequired();

                    b.Property<string>("Name");

                    b.HasKey("Id");

                    b.ToTable("CategoryGroup");

                    b.HasDiscriminator<string>("Discriminator").HasValue("CategoryGroup");
                });

            modelBuilder.Entity("EfInheritance.Models.Division", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.HasKey("Id");

                    b.ToTable("Divisions");
                });

            modelBuilder.Entity("EfInheritance.Models.DivisionCategory", b =>
                {
                    b.Property<int>("CategoryId");

                    b.Property<int>("DivisionId");

                    b.Property<string>("Discriminator")
                        .IsRequired();

                    b.HasKey("CategoryId", "DivisionId");

                    b.ToTable("DivisionCategory");

                    b.HasDiscriminator<string>("Discriminator").HasValue("DivisionCategory");
                });

            modelBuilder.Entity("EfInheritance.Models.AgeCategory", b =>
                {
                    b.HasBaseType("EfInheritance.Models.Category");

                    b.Property<int>("MaxAge");

                    b.Property<int>("MinAge");

                    b.ToTable("AgeCategory");

                    b.HasDiscriminator().HasValue("AgeCategory");
                });

            modelBuilder.Entity("EfInheritance.Models.GenderCategory", b =>
                {
                    b.HasBaseType("EfInheritance.Models.Category");


                    b.ToTable("GenderCategory");

                    b.HasDiscriminator().HasValue("GenderCategory");
                });

            modelBuilder.Entity("EfInheritance.Models.AgeCategoryGroup", b =>
                {
                    b.HasBaseType("EfInheritance.Models.CategoryGroup");


                    b.ToTable("AgeCategoryGroup");

                    b.HasDiscriminator().HasValue("AgeCategoryGroup");
                });

            modelBuilder.Entity("EfInheritance.Models.GenderCategoryGroup", b =>
                {
                    b.HasBaseType("EfInheritance.Models.CategoryGroup");


                    b.ToTable("GenderCategoryGroup");

                    b.HasDiscriminator().HasValue("GenderCategoryGroup");
                });

            modelBuilder.Entity("EfInheritance.Models.AgeDivisionCategory", b =>
                {
                    b.HasBaseType("EfInheritance.Models.DivisionCategory");


                    b.HasIndex("DivisionId");

                    b.ToTable("AgeDivisionCategory");

                    b.HasDiscriminator().HasValue("AgeDivisionCategory");
                });

            modelBuilder.Entity("EfInheritance.Models.GenderDivisionCategory", b =>
                {
                    b.HasBaseType("EfInheritance.Models.DivisionCategory");


                    b.HasIndex("DivisionId")
                        .HasName("IX_DivisionCategory_DivisionId1");

                    b.ToTable("GenderDivisionCategory");

                    b.HasDiscriminator().HasValue("GenderDivisionCategory");
                });

            modelBuilder.Entity("EfInheritance.Models.Category", b =>
                {
                    b.HasOne("EfInheritance.Models.CategoryGroup", "CategoryGroup")
                        .WithMany("Categories")
                        .HasForeignKey("CategoryGroupId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("EfInheritance.Models.DivisionCategory", b =>
                {
                    b.HasOne("EfInheritance.Models.Category", "Category")
                        .WithMany("DivisionCategories")
                        .HasForeignKey("CategoryId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("EfInheritance.Models.AgeDivisionCategory", b =>
                {
                    b.HasOne("EfInheritance.Models.Division", "Division")
                        .WithMany("AgeGroups")
                        .HasForeignKey("DivisionId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("EfInheritance.Models.GenderDivisionCategory", b =>
                {
                    b.HasOne("EfInheritance.Models.Division", "Division")
                        .WithMany("GenderGroups")
                        .HasForeignKey("DivisionId")
                        .HasConstraintName("FK_DivisionCategory_Divisions_DivisionId1")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
